=== libs/backends/dummy/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os
import sys
import re

I18N_PACKAGE = 'dummy-backend'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    autowaf.configure(conf)

def build(bld):
    obj = bld(features = 'cxx cxxshlib')
    obj.source = [
            'dummy_audiobackend.cc',
            ]
    obj.includes = ['.']
    obj.name     = 'dummy_audiobackend'
    obj.target   = 'dummy_audiobackend'
    obj.use      = 'libardour libpbd'
    obj.uselib   = 'GLIBMM XML'
    obj.install_path  = os.path.join(bld.env['LIBDIR'], 'backends')
    obj.defines = ['PACKAGE="' + I18N_PACKAGE + '"',
                   'ARDOURBACKEND_DLL_EXPORTS'
                  ]
