=== debian/changelog ===
ardour (1:5.5.0~dfsg-1) unstable; urgency=medium

  [ Jaromír Mikeš ]
  * New upstream version 5.5.0~dfsg
  * Patches refreshed/removed.
  * copyright_hints updated.
  * Add libhidapi-dev as B-D.
  * Update copyright.
  * Sign tags.
  * Set dh/compat 10.

  [ IOhannes m zmölnig ]
  * Removed extranous commas in dependency-list
  * B-D on libqm-dsp-dev
  * B-D on libusb-1.0-0-dev (Closes: #844413)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 03 Dec 2016 14:52:10 +0100

ardour (1:5.4.0~dfsg-2) unstable; urgency=medium

  * Versioned dependency on ardour-data (Closes: #841868)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 24 Oct 2016 12:05:06 +0200

ardour (1:5.4.0~dfsg-1) unstable; urgency=medium

  * New upstream version 5.4.0

  [ Jaromír Mikeš ]
  * Patch refreshed.
  * Tune up b-deps.
  * Update copyright file.
  * Tune watch file to add dfsg suffix on repack.

  [ IOhannes m zmölnig ]
  * Build with 'dummy' backend.
    Thanks to rgareus
  * Added minimal manpages for session utilities
  * Fixed URL to upstream tracker
  * Added ardour-video-timeline package (Closes: #840836)
    * Added lintian-overrides for ardour-video-timeline
    * Mention ardour-video-timeline in warning messages
  * d/patches/
    * More spelling fixes
    * Refreshed patches
  * d/control
    * B-D on libarchive-dev
    * Added Multi-Arch fields
    * Added cdbs:Suggests to dependencies
    * Added continuation comma to multline fields
    * Regenerated d/control
  * Updated d/copyright
    * Dropped unused BSD-4-clause license from d/copyright
  * Refreshed d/copyright(_hints)
  * Updated d/watch
    * (Temporarily) dropped repacksuffix

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 18 Oct 2016 21:03:16 +0200

ardour (1:5.3~dfsg-1) unstable; urgency=medium

  * New upstream version 5.3~dfsg

  [ Jaromír Mikeš ]
  * Change upstream email.
  * Add more excluded files to rules file.

  [ IOhannes m zmölnig ]
  * Refreshed patches
  * Added libfluidsynth-dev to Build-dependencies
  * Multiline Files-Excluded
  * Filter-out non-dfsg files in import-orig
  * Updated copyright dates
  * Refreshed d/copyright_hints
  * d/watch: use downloadurlmangle to fetch tarball from ardour-website

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 30 Aug 2016 11:47:57 +0200
